HyperNav = HyperNav or {}

-- load the navigation data file
dofile('data.lua')

HyperNav.DestinationSector = 0

function HyperNav.GetRoute(from, to)
	local res = {}
	if HyperNav.Routes[from.."-"..to] then
		res = HyperNav.Routes[from.."-"..to]
	end
	return res
end

-- convert navroute into optimal route
function HyperNav.PlotRoute()
	local currSectorId = GetCurrentSectorid()
	local destSectorId = NavRoute.GetFinalDestination()

	local currRoute = NavRoute.GetCurrentRoute()
	local currFullRoute = GetFullPath(currSectorId, currRoute)

	if destSectorId==nil then
		print("\127ffb935HyperNav: \127ffffffUnknown destination sector.")
		return
	end
	if destSectorId==currSectorId and #currFullRoute<1 then
		print("\127ffb935HyperNav: \127ffffffStart and destination sector are the same - nothing to plot.")
		return
	end

	local fullRoute = {}
	local newRoute = {}
	local done = {}
	local prev = 0
	for i,v in ipairs(currFullRoute) do
		if prev ~= v then
			table.insert(fullRoute, v)
			prev = v
		end
	end
	local to = ""
	local from = ""
	for i=1,#fullRoute-1 do
		from = fullRoute[i]
		to = fullRoute[i+1]
		if from~=nil and to~=nil then
			local points = HyperNav.GetRoute(from, to)
			if (#points) then
				for i,v in ipairs(points) do
					table.insert(newRoute, tonumber(v))		
				end
			else
				table.insert(newRoute, from)
			end
		end
	end
	table.insert(newRoute, to)
	local finalRoute = {}

	if #newRoute>0 then
		NavRoute.clear()		
		NavRoute.SetFullRoute(newRoute)
		print("\127ffb935HyperNav: \127ffffffNew route plotted (" .. ShortLocationStr(currSectorId) .. " -> " .. ShortLocationStr(destSectorId) .. ")")
	else
		print("\127ffb935HyperNav: \127ffffffCould not plot route. Unknown error.")
	end
end


--set navroute to sector
function SetJump(sector)
	local sectorid = SectorIDFromLocationStr(sector) or SectorIDFromLocationStr(SystemNames[GetCurrentSystemid()].." "..sector)
	if not sectorid then
		purchaseprint("Your Nav Computer cannot process that sector. Check for spelling errors.")
		return
	elseif sectorid == GetCurrentSectorid() then
		purchaseprint("You are already in "..ShortLocationStr(sectorid))
		return
	end
	NavRoute.SetFullRoute{sectorid}
	purchaseprint("Your Nav Computer has plotted a course to "..ShortLocationStr(sectorid))
end
RegisterUserCommand("Jump", function(_,arg) 
								SetJump(table.concat(arg, " "))
							end)
gkinterface.GKProcessCommand("alias jump_prompt \"prompt Jump \"")

--set navroute and use hyper jump
function HyperJump(sector)
	SetJump(sector)
	HyperNav.PlotRoute()
	purchaseprint("Your Nav Computer used hyper mode.")
end
RegisterUserCommand("Hyperjump", function(_,arg) 
									HyperJump(table.concat(arg, " "))
								end)
gkinterface.GKProcessCommand("alias hyperjump_prompt \"prompt Hyperjump \"")